#pragma once
#include <string>
#include "srcMap/point.h"
#include "srcMap/StructureCarte.h"

using namespace std;

class Action
{

protected:
	Action* CopyActionDataTo(Action* inClonedAction) const;
public:

	enum TAction {
		eUndefined = -1,
		eRoad = 0,
		eTerminal = 1,
		eWait = 2,

		eMax
	};

	static const string enumAssociation[eMax];

	Point mPosition;
	string mName = "No name";
	float mDuration = 0.0f;
	float mStartTime = 0.0f;

	inline virtual string getName() const { return mName; }

	virtual string toString() const;
	virtual Point getPosition() const { return mPosition; }
	virtual float getDuration() const { return mDuration; }
	virtual float getStartTime() const { return mStartTime; }
	TimeRange getTimeRange() const { return TimeRange(TimeUnit(mStartTime),TimeUnit(mStartTime+mDuration)); }
	virtual TAction getType() const = 0;
	virtual Action* clone() const = 0;

	Action();
	virtual ~Action();
};

