#pragma once

#include <unordered_map>
#include <string>

class ElectricTerminal;
class Carte;

using namespace std;

class ElectricCircuit
{
private:
	unordered_map<int,ElectricTerminal*> mMapStation;

public:
	ElectricCircuit(const Carte& inCarte);
	ElectricCircuit(const ElectricCircuit &otherEc);
	ElectricCircuit* clone() const;
	~ElectricCircuit();
	ElectricTerminal* GetByIndexLieu(int inIndexLieu) const;

	unsigned int size() const { return mMapStation.size(); }
	unsigned int computeTotalReservation() const;

	friend ostream& operator<<(ostream& os, const ElectricCircuit& dt);
	
};


ostream& operator<<(ostream& os, const ElectricCircuit& dt);


