#include "ISystemSolver.h"
#include "ScenarioData.h"
#include "PerformanceAnalysis.h"
#include "SystemSolution.h"


ISystemSolver::ISystemSolver(IObjectiveFunction * inObjectiveFunction, IVehicleSolver * inVehicleSolver, ElectricCircuit* inElectricCircuit)
:mObjectiveFunction(inObjectiveFunction), mVehicleSolver(inVehicleSolver)
{
	mSolverData = new ScenarioData();
	mSolverData->mElectricCircuit = inElectricCircuit;

	mPerformanceAnalysis = new PerformanceAnalysis();
}

ISystemSolver::~ISystemSolver()
{
	//TODO:have a different object that shallow cop the data
	//delete mSolverData;
	delete mPerformanceAnalysis;
}

void ISystemSolver::AddVehicle(Vehicle * newVehicle)
{
	if (mIsActivated)
	{
		AddVehicleInternal(newVehicle);
	}
}

void ISystemSolver::RemoveVehicle(Vehicle * newVehicle)
{
	if (mIsActivated)
	{
		RemoveVehicleInternal(newVehicle);
	}
}
