#include "ScenarioLoader.h"


#include <assert.h>
#include <iostream>
#include <fstream>
#include <iomanip>

#include "Scenario.h"
#include "srcMap/StructureCarte.h"
#include "Vehicle.h"
#include "ElectricCircuit.h"
#include "ScenarioData.h"
#include "Vehicle.h"

const string ScenarioLoader::NO_SCENARIO = "None!";

ScenarioLoader::ScenarioLoader(std::string filename, const Carte & carte)
	:mFileName(filename),
	mRefCarte(carte)
{
}

void ScenarioLoader::Load(ScenarioData* outRefData)
{
	if (mFileName.compare(NO_SCENARIO) != 0)
	{
		std::ifstream file(mFileName);

		if (file.is_open())
		{
			while (file) {

				LoadNextVehicle(file, outRefData);
				if (!file) break;
			}
		}
		else
		{
			cout << "***** ERROR: could not open file " << mFileName << endl;
		}

		file.close();
		cerr << "Scenario charge!" << endl;
	}
	outRefData->mElectricCircuit = new ElectricCircuit(mRefCarte);
}

void ScenarioLoader::LoadNextVehicle(std::istream& inDataVehicle, ScenarioData* outRefData)
{
	string nom;
	Point a, b;
	float aut;
	float depart;
	float l1charge;
	inDataVehicle >> nom;
	inDataVehicle >> a >> b >> aut >> depart >> l1charge >> ws;
	//TODO: regler la conversion d'unite
	outRefData->mVecVehicle.push_back(new Vehicle(nom, a, b, aut, depart, l1charge));

}

void ScenarioLoader::LoadNextNamelessVehicle(std::istream & inDataVehicle, ScenarioData* outRefData)
{
	string nom = "Generic_" + std::to_string(mNamelessID);
	++mNamelessID;
	Point a, b;
	float aut;
	float depart = 0.0f;
	float l1charge = 1800.0f;
	inDataVehicle >> a >> b >> aut >> l1charge >> ws;
	//TODO: regler la conversion d'unite
	outRefData->mVecVehicle.push_back(new Vehicle(nom, a, b, aut, depart, l1charge));
}

ScenarioLoader::~ScenarioLoader()
{
}
