#pragma once

#include <string>
#include "IScenarioLoader.h"

class Carte;
class ElectricCircuit;
class ScenarioData;
class Vehicle;

class ScenarioLoader : public IScenarioLoader
{
private :
	std::string mFileName;
	const Carte& mRefCarte;

	int mNamelessID = 1;

public:
	static const std::string NO_SCENARIO;

	ScenarioLoader(std::string filename, const Carte & carte);
	virtual void Load(ScenarioData* outRefData);
	//Return new Vehicle loaded
	virtual void LoadNextVehicle(std::istream& inDataVehicle, ScenarioData* outRefData);
	virtual void LoadNextNamelessVehicle(std::istream& inDataVehicle, ScenarioData* outRefData);
	~ScenarioLoader();
};

