#include "SystemSolver.h"

#include <algorithm>

#include "ScenarioData.h"
#include "SystemSolution.h"
#include "ElectricCircuit.h"
#include "IArrangement.h"

#include <assert.h>

SystemSolver::SystemSolver(IObjectiveFunction* inObjectiveFunction, IVehicleSolver* inVehicleSolver, IArrangement* inArrangement,ElectricCircuit* inElectricCircuit)
:ISystemSolver(inObjectiveFunction,inVehicleSolver, inElectricCircuit),
mArrangement(inArrangement)
{
	ResetSolution();

}

SystemSolver::~SystemSolver()
{
	delete mSystemSolution;
}

void SystemSolver::ResetSolution()
{
	if (mSystemSolution != nullptr)
	{
		delete mSystemSolution;
	}
	mSystemSolution = new SystemSolution();
}

void SystemSolver::AddVehicleInternal(Vehicle * newVehicle)
{
	mSolverData->mVecVehicle.push_back(newVehicle);
}

void SystemSolver::RemoveVehicleInternal(Vehicle * newVehicle)
{
	auto vIt = find(mSolverData->mVecVehicle.begin(), mSolverData->mVecVehicle.end(), newVehicle);
	if (vIt != mSolverData->mVecVehicle.end())
	{
		mSolverData->mVecVehicle.erase(vIt);
	}
}
