#pragma once
#include "ISystemSolver.h"

class ScenarioData;
class IObjectiveFunction;
class IVehicleSolver;
class IArrangement;

class SystemSolver :
	public ISystemSolver
{
protected:
	SystemSolution* mSystemSolution = nullptr;
	IArrangement* mArrangement = nullptr;

	void ResetSolution();

	//These will solve when adding and removing candidates
	virtual void AddVehicleInternal(Vehicle* newVehicle);
	virtual void RemoveVehicleInternal(Vehicle* newVehicle);

public:
	SystemSolver(IObjectiveFunction* inObjectiveFunction,IVehicleSolver* inVehicleSolver, IArrangement* inArrangement, ElectricCircuit* inElectricCircuit);
	virtual ~SystemSolver();

	virtual SystemSolution* GetCurrentSystemSolution() const { return mSystemSolution; }

};

