#pragma once
#include "SystemSolver.h"
#include <math.h>

class Vehicle;

//Strong dependency to VehicleSolverIgnoreStationOptimal
class SystemSolverSweepWindow :
	public SystemSolver
{
private:
	ISystemSolver* mBestSolver = nullptr;
	ElectricCircuit* mBestCircuit = nullptr;

	virtual void AddVehicleInternal(Vehicle* newVehicle);

	//How much we solve forward
	float mfWindowWidth = 1000.0f;
	//How often we recompute
	float mfResolveStep = mfWindowWidth / 2.0f;

	float mfMinimumDepartureTime = INFINITY;

public:

	SystemSolverSweepWindow(IObjectiveFunction* inObjectiveFunction, IVehicleSolver* inVehicleSolver, ElectricCircuit* inElectricCircuit,float infWindowWidth,float infResolveStep);
	virtual ~SystemSolverSweepWindow();

	virtual void SolveSystem();
};